/* Limited manual (non-WarpIn) ESS Maestro 2E backend installation by Lesha Bogdanow.
   Requires wic.exe from WarpIn 0.96 or above to be available in
   one of PATH directories.
*/
wicx="-x"
src="lb_m2e.wpi"

call RxFuncAdd "SysLoadFuncs","REXXUTIL","SysLoadFuncs"
call SysLoadFuncs

WarpIn=stream("wic.exe","c","query exists")
if WarpIn="" then WarpIn=EScan("PATH","wic.exe")
if WarpIn="" then do
   WarpIn=SysIni(,"WarpIN","Path")
   if (WarpIn<>'ERROR:')&(length(WarpIn)>1) then do
      if right(WarpIn,1)=D2C(0) then WarpIn=left(WarpIn,length(WarpIn)-1)
      if right(WarpIn,1)<>"\" then WarpIn=WarpIn||"\"
      WarpIn=stream(WarpIn||"wic.exe","c","query exists")
      end
   else WarpIn=""
end
if WarpIn<>"" then do
   if TestRun(WarpIN)=0 then do
      p=lastpos("\",WarpIn)
      if p>1 then
         "@SET BEGINLIBPATH="left(WarpIn,p-1)";"value('BEGINLIBPATH',,'OS2ENVIRONMENT')
      end
   if TestRun(WarpIN)=0 then WarpIn=""
   end
if WarpIn="" then do 
   say "Unable to locate or execute wic.exe from WarpIN package."
   say "Make sure you have WarpIn 0.9.6 or above installed or wic.exe and"
   say "wpirtl.dll are placed in the current or one of PATH directories."
   exit(1)
   end
wicx=WarpIn wicx

src=stream(src,'c',"query exists")
if src="" then do
   say "You have to place lb_m2e.wpi file into the current directory."
   exit(1)
   end
if SysSetObjectData("<PIPEMIX_FOLDER>","")<>1 then do
   say "You have to install Pipe Mixer Backend set first."
   exit(2)
   end
if stream("PipeMix.inf","c","query exists")="" then do
   say "You have to run this script from the Pipe Mixer Backend directory."
   exit(2)
   end
say "This is a limited manual ESS Maestro 2E backend installation utility. It will"
say "unpack ESS Meastro 2E backend into the current directory and create ESS"
say "Maestro 2E backend manual WPS object in the present Pipe Mixer Backend folder."
say "Proceed with installation? (Y/N):"
do until rsp='Y'
   parse pull rsp
   rsp=translate(left(rsp,1))
   if rsp='N' then do
      say "Installation aborted."
      exit(1)
      end
   else if rsp<>'Y' then say "Invalid input. Enter Y(es) or N(o):"
   end
dir=directory()
call Unpack 1
say "Creating ESS Maestro 2E Backend objects."
fdir=dir
if right(fdir,1)<>"\" then fdir=fdir||"\"
call SysCreateObject "WPProgram","ESS Maestro 2E Manual","<PIPEMIX_FOLDER>","OBJECTID=<PIPE_M2E_MANUAL>;EXENAME=VIEW.EXE;STARTUPDIR="||fdir||".;ICONFILE="||fdir||"PMixInf.ico;PARAMETERS="||fdir||"M2E.inf"
say "Installation complete. See Pipe Mixer Backend manual and ESS Maestro 2E manual"
say "for details on configuration and usage."
say "You can delete M2EIns.cmd and lb_m2e.wpi now."
exit(0)

Unpack:
   wicx src arg(1)
   if rc<>0 then do
      say "Failed to decompress .wpi archive. Make sure wic.exe from WarpIn 0.96 or"
      say "above is available in one of PATH directories."
      exit(1)
      end
   return

TestRun:
   procedure
   exe=arg(1)
   "@"exe "2>nul|rxqueue"
   if queued()=0 then return 0
   parse pull result
   return pos("GNU General Public Licence",result)

/* Scan environment var arg(1) for a directory with file arg(2) */
EScan:
   procedure
   var=value(arg(1),,'OS2ENVIRONMENT')
   file=arg(2)
   ret=''
   do while (var<>'')&(ret='')
      if pos(';',var)<>0 then do
         dir=left(var,pos(';',var)-1)
         var=substr(var,pos(';',var)+1)
         end
      else do
         dir=var
         var=''
         end
      dir=strip(dir)
      if dir<>'' then do
         if right(dir,1)<>'\' then dir=dir'\'
         ret=stream(insert(dir,file),'c','query exists')
         end
      end
   return ret
